# Need to get x_for_q4 y_for_q4 from Q3
x=x_for_q4
y=y_for_q4
# normalize y_max as 1e3
nrml=1e3
amplitude=np.max(y)
y/=amplitude
y*=nrml
amplitude=nrml

### 구현하기
def intensity(x, amplitude, k):
  return amplitude*(np.sin(k*x)/(k*x))**2
  ## return amplitude*np.sinc(k*x)

"""
def dI_dk(k):
  global x, amplitude
  num=2*amplitude*np.sin(k*x)*(k*x*np.cos(k*x)-np.sin(k*x))
  denum=k**3*x**2
  return num/denum
"""

# Gradient with Three point Taylor expension
def df_dk(func, k):
  global x, amplitude
  h=1e-8
  return (func(x, amplitude, k+h)-func(x, amplitude, k-h))/(2*h)

# LSQ=1/N*SUM((y_pred-y_true)**2)
def LSE(k):
  global x, y, intensity, amplitude
  lse=np.mean((intensity(x, amplitude, k)-y)**2)
  return lse

if __name__=="__main__":
  learning_rate = 1e-2
  lsq_all = []

  k=1
  for i in range(10000):
    lsq=LSE(k)
    # grad = (2*(intensity(x, amplitude, k)-y)*dI_dk(k)).mean()
    grad=np.mean(2*(intensity(x, amplitude, k)-y)*df_dk(intensity, k))
    k-= grad*learning_rate
    lsq_all.append(lsq)

  plt.plot(lsq_all, color="#ff00ff")
  plt.title("Loss")
  plt.yscale("log"); plt.ylabel(f"$Loss[log]$")
  plt.show()
  print("\n", end="", flush=True)

  y_pred=intensity(x, amplitude, k)

  ax=plt.subplot(121)
  ax.plot(x, y, color="#00a3d2")
  ax.set_title("y_true")
  plt.xticks([]); plt.yticks([])
  ax=plt.subplot(122)
  ax.plot(x, y_pred, color="#881824")
  ax.set_title("y_pred")
  plt.xticks([]); plt.yticks([])
  plt.show()
  print("\n", end="", flush=True)

  plt.plot(x, y, color="#00a3d2", alpha=0.3, label="y_true")
  plt.plot(x, y_pred, color="#881824", alpha=0.3, label="y_pred")
  plt.title("k=%.2f" %k)
  plt.legend()
  plt.show()
